<?

// The script measures time needed for opening SMTP session, wait for 220-*
// SMTP server ready prompt and QUIT operation

$smtp_box = $argv[1];	// SMTP server hostname (IP)
$timeout  = 300;		// usually SMTP servers use quite long timeout

$errno = 0;
$errstr = "";

$start_time = time();	// you may consider using microtime to get better resolution

$fp = fsockopen($smtp_box, 25, $errno, $errstr, $timeout);

if($fp !== false) {
	stream_set_timeout($fp, $timeout);		// set the same timeout for read operation as for opening socket

	$res = fread($fp, 4096);
	$info = stream_get_meta_data($fp);

	if($info['timed_out'] === false) {
		if(strpos($res, "220") === 0) {

			stream_set_timeout($fp, 10);	// now we can lowe timeout
			fwrite($fp, "QUIT\r\n");		// you need to wait for prompt before issueing QUIT command according to RFC (if server does not support pipelining)
			fread($fp, 4096);

			print time() - $start_time;
		}
		else {
			print "Unexpected response - $res\n";
		}
	}
	else {
		print "Read timeout.\n";
	}

	fclose($fp);
}
else {
	print "Error no $errno - $errstr.\n";
}

?>
